﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Configuration;
using System.Web.Configuration;
using Formsy.Config.Providers;
using Formsy.Config;

namespace Formsy.Providers.PrePopulate
{
    public class PrePopulateProviderManager
    {
        private static PrePopulateProvider m_DefaultProvider;
        private static PrePopulateProviderCollection m_Providers;

        private static string SectionGroupName = Settings.SectionName;
        private static string SectionName = "PrePopulateProviderSettings";


        static PrePopulateProviderManager()
        {
            Initialize();
        }

        private static void Initialize()
        {
            Configuration config = WebConfigurationManager.OpenWebConfiguration("~\\Web.config");
            var group = config.GetSectionGroup(SectionGroupName);

            PrePopulateProviderSettings configuration = (PrePopulateProviderSettings)group.Sections[SectionName];

            if (configuration == null)
                throw new ConfigurationErrorsException("PrePopulate Provider configuration section is not set correctly.");

            m_Providers = new PrePopulateProviderCollection();

            ProvidersHelper.InstantiateProviders(configuration.Providers, m_Providers, typeof(PrePopulateProvider));

            m_Providers.SetReadOnly();

            m_DefaultProvider = m_Providers[configuration.Default];

            if (m_DefaultProvider == null)
                throw new Exception("Failed to load provider: " + configuration.Default);
        }

        public static PrePopulateProvider Provider
        {
            get
            {
                return m_DefaultProvider;
            }
        }

        public static PrePopulateProviderCollection Providers
        {
            get
            {
                return m_Providers;
            }
        }
    }
}