﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Configuration;
using System.Web.UI.WebControls;
using System.Configuration.Provider;
using System.Xml.Linq;

namespace Formsy.Providers.DataSource
{
    public abstract class DataSourceProvider : ProviderBase
    {
        /// <summary>
        /// 
        /// </summary>
        /// <param name="param">A list of XElements containing string parameters in the xml file. I would have called this params but it's reserved.</param>
        /// <returns>A list of ListItem</returns>
        public abstract List<ListItem> GetListItems(List<XElement> parameters);
    }


    public class DataProviderCollection : ProviderCollection
    {
        // Return an instance of DataProvider
        // for a specified provider name
        new public DataSourceProvider this[string name]
        {
            get { return (DataSourceProvider)base[name]; }
        }
    }
}

